Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model Java API Reference 10g Release 3 (10.1.3) B25778-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.jbo.uicli.graph
Class BIBeanDataAccessAdapter

`java.lang.Object
oracle.dss.util.DataAccessAdapter
oracle.jbo.uicli.graph.BIBeanDataAccessAdapter`

All Implemented Interfaces:
  oracle.dss.util.CubeDataDirector, oracle.dss.util.DataAccess, oracle.dss.util.DataAccess2, oracle.dss.util.DataDirector, oracle.dss.util.DataDirector2, oracle.dss.util.RelationalDataDirector

public class BIBeanDataAccessAdapter
extends oracle.dss.util.DataAccessAdapter
implements oracle.dss.util.RelationalDataDirector, oracle.dss.util.CubeDataDirector

Internal class used to define data source of BI Graph bean.

Field Summary
`protected oracle.dss.util.DataDirectorListener` | `mListener`

Fields inherited from interface oracle.dss.util.DataDirector
`COLUMN_EDGE, DATA_ELEMENT_EDGE, DRILL_BACK, DRILL_COLLAPSE, DRILL_REPLACE, DRILL_TO_PARENT, DRILL_TO_PARENT_AND_SIBLINGS, DRILLSTATE_DRILLABLE, DRILLSTATE_IS_DRILLED, DRILLSTATE_NOT_DRILLABLE, GRAND_TOTAL_LAYER, GROUPSORT_END, GROUPSORT_MIDDLE, GROUPSORT_NONE, GROUPSORT_START, max_edge, NA_SUPPRESSION, NA_ZERO_SUPPRESSION, NO_SUPPRESSION, NO_TOTALS, PAGE_EDGE, PIVOT_EDGES, PIVOT_MOVE_AFTER, PIVOT_MOVE_BEFORE, PIVOT_MOVE_TO, PIVOT_SWAP, ROW_EDGE, TOTAL_ALL_LAYERS, TOTAL_AVERAGE, TOTAL_MAXIMUM, TOTAL_MINIMUM, TOTAL_SUM, ZERO_SUPPRESSION`

Fields inherited from interface oracle.dss.util.DataAccess
`DATATYPE_BOOLEAN, DATATYPE_DATE, DATATYPE_DOUBLE, DATATYPE_FLOAT, DATATYPE_INTEGER, DATATYPE_LONG, DATATYPE_SHORT, DATATYPE_STRING, FIND_CASE_INSENSITIVE, FIND_CONTAINS, FIND_ENDS_WITH, FIND_EXACT, FIND_PRIOR, FIND_STARTS_WITH, QDR_WITH_PAGE, QDR_WITHOUT_PAGE`

Fields inherited from interface oracle.dss.util.DataDirector2
`PROP_CACHE_LIMIT, PROP_COLUMN_SORTS_SUPPORTED, PROP_DD2_DRILL_SUPPORTED, PROP_DD2_VARIABLE_DRILLPATHS, PROP_EDGE_EXTENT_AVAILABLE, PROP_HIDDEN_EDGE_SUPPORTED, PROP_PAGE_SORTS_SUPPORTED, PROP_REL_INDENT_SCAN_LIMIT, PROP_SORTS_SUPPORTED, PROP_TOTALS_VISIBLE, PROP_UNIQUE_MEMBERS_SCAN_LIMIT, SORT_DIRECTION_ASCENDING, SORT_DIRECTION_DESCENDING, SORT_TYPE_GROUPSORT, SORT_TYPE_GROUPSORT_PAGEBREAK, SORT_TYPE_NORMAL`

Constructor Summary
`BIBeanDataAccessAdapter(JUGraphBinding owner)`

Method Summary
`void` | `addDataDirectorListener(oracle.dss.util.DataDirectorListener l)` NEW Register a listener to the data source for changes.
`boolean` | `changeEdgeCurrentSlice(int edge, int slice)` Changes the current slice of data on the given edge.
`boolean` | `drill(int edge, int layer, int slice, int flags)` Drills in the data, from a single member.
`int` | `getEdgeCount()` Return the total number of edges in the data source.
`int` | `getEdgeCurrentSlice(int edge)` Retrieves the number of the current slice.
`int` | `getEdgeExtent(int edge)` Retrieves the total number of members on the given edge.
`int` | `getLayerCount(int edge)` Retrieves the number of layers on the specified edge.
`int` | `getMemberDepth(int edge, int layer, int slice)` Retrieves the number of layers that a member spans at the specified location on the specified edge.
`int` | `getMemberExtent(int edge, int depth, int slice)` Retrieves the number of slices that a member spans.
`java.lang.Object` | `getMemberMetadata(int edge, int layer, int slice, java.lang.String type)` Retrieves a piece of metadata for a dimension member.
`int` | `getMemberStartLayer(int edge, int layer, int slice)` Retrieves the starting slice of a member that spans a number of layers on the specified edge.
`java.lang.Object` | `getSliceLabel(int edge, int slice, java.lang.String type)` Retrieves the label for the specified column.
`int` | `getSliceMemberCount(int edge, int slice)` Retrieves the number of logical layers at the specified location on the specified edge.
`oracle.dss.util.DataMap` | `getSupportedDataMap()`
`oracle.dss.util.LayerMetadataMap` | `getSupportedLayerMetadataMap()`
`oracle.dss.util.MetadataMap` | `getSupportedMetadataMap()`
`java.lang.Object` | `getValue(int aRow, int aColumn, java.lang.String type)` Retrieves a data value for the specified row and column intersection.
`boolean` | `pivot(int fromEdge, int toEdge, int fromLayer, int toLayer, int flags)` Pivots data.
`boolean` | `refresh()`
`void` | `removeDataDirectorListener(oracle.dss.util.DataDirectorListener l)` NEW Remove a listener from the data source.
`boolean` | `setValue(java.lang.Object aValue, int aRow, int aColumn, java.lang.String type)`

Methods inherited from class oracle.dss.util.DataAccessAdapter
`allSlicesFetched, cancel, changeEdgeCurrentHPos, deleteMemberCalc, deleteValueCalc, drill, drill, drill, drillOK, drillOK, drillOK, drillOK, dropChanges, endGroupEdit, findMember, forceFetch, getColumnSorts, getCorrespondingMemberMetadata, getCorrespondingMemberMetadata, getDataMap, getEdgeCurrentHPos, getFirstHPos, getLastHPos, getLayerMetadata, getLayerQDR, getMemberHPos, getMemberLogicalLayer, getMemberMetadata, getMemberQDR, getMemberQDR, getMemberSiblingCount, getMemberStartSlice, getMetadataMap, getNextHPos, getPrevHPos, getProperty, getQDRoverrideCollection, getSliceOutlineLayer, getSliceQDR, getSorts, getUniqueDataValues, getUniqueMemberMetadata, getUniqueMemberMetadata, getValueQDR, insertMemberCalc, insertValueCalc, isAutoSubmit, isCancelable, isFetched, isOutline, pivotOK, redoEdit, release, reorder, revalidate, setAutoSubmit, setColumnSorts, setDataMap, setManualUpdate, setMetadataMap, setOutline, setProperty, setSorts, startGroupEdit, submitChanges, undoEdit, update`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface oracle.dss.util.DataDirector
`cancel, changeEdgeCurrentHPos, deleteMemberCalc, deleteValueCalc, drill, drillOK, drillOK, getDataMap, getMetadataMap, insertMemberCalc, insertValueCalc, isCancelable, isOutline, pivotOK, reorder, revalidate, setDataMap, setManualUpdate, setMetadataMap, setOutline, update`

Field Detail

### mListener

    protected oracle.dss.util.DataDirectorListener mListener

Constructor Detail

### BIBeanDataAccessAdapter

    public BIBeanDataAccessAdapter(JUGraphBinding owner)

Method Detail

### pivot

    public boolean pivot(int fromEdge,
                         int toEdge,
                         int fromLayer,
                         int toLayer,
                         int flags)
                  throws oracle.dss.util.EdgeOutOfRangeException,
                         oracle.dss.util.LayerOutOfRangeException,
                         oracle.dss.util.DataDirectorException

  Pivots data. Operations include:
  - Moving dimensions or dimension members from one edge to another.
  - Moving dimensions or dimension members from one location on an edge to another location on the same edge.
  - Swapping the locations of two dimensions.
  - Swapping two edges.
  Specified by:
    `pivot` in interface `oracle.dss.util.DataDirector`
  Parameters:
    `fromEdge` - The edge to pivot from.
    `toEdge` - The edge to pivot to.
    `fromLayer` - The layer to pivot from. The layer identifies the location of the dimension or dimension member; 0 is the outer-most dimension on the edge.
    `toLayer` - The layer to pivot to.
    `flags` - Constant that indicates the type of pivot to perform. The constants begin with PIVOT_ in this interface.
  Returns:
    `true` if the pivot is successful, `false` if not.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If either edge is too large.
    `oracle.dss.util.LayerOutOfRangeException` - If either layer is negative or too large.
    `oracle.dss.util.DataDirectorException` - If a data provider error occurs.

### drill

    public boolean drill(int edge,
                         int layer,
                         int slice,
                         int flags)
                  throws oracle.dss.util.EdgeOutOfRangeException,
                         oracle.dss.util.LayerOutOfRangeException,
                         oracle.dss.util.SliceOutOfRangeException,
                         oracle.dss.util.DataDirectorException

  Drills in the data, from a single member.
  Specified by:
    `drill` in interface `oracle.dss.util.DataDirector`
  Parameters:
    `edge` - The edge to drill.
    `layer` - The layer to drill. The layer identifies the location of the dimension or dimension member; 0 is the outer-most dimension on the edge.
    `slice` - The slice to drill. The slice is zero-based. Each dimension member in the innermost dimension has a unique slice. In outer dimensions, any slice that the outer dimension spans can be used.
    `flags` - Constant that indicates the type of drill. The constants begin with DRILLABLE_ in this interface.
  Returns:
    `true` If drilling is successful, `false` if not.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is too large.
    `oracle.dss.util.LayerOutOfRangeException` - If `layer` is negative or too large.
    `oracle.dss.util.SliceOutOfRangeException` - If `slice` is negative or too large.
    `oracle.dss.util.DataDirectorException` - If a data provider error occurs.

### getEdgeExtent

    public int getEdgeExtent(int edge)
                      throws oracle.dss.util.EdgeOutOfRangeException

  Retrieves the total number of members on the given edge. cursor.
  Specified by:
    `getEdgeExtent` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `edge` - Edge of interest.
  Returns:
    The total number of members on the given edge.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException`

### getEdgeCount

    public int getEdgeCount()

  Return the total number of edges in the data source. Note: the views will consider all edges beyond 0 and 1 (column/ row) to be page edges, and some of the methods retrieving page counts, etc., may involve view calculations from more basic data source information. The views assume that the data source will ascribe column/row meaning to the first two edges on any query.
  Specified by:
    `getEdgeCount` in interface `oracle.dss.util.DataAccess`
  Returns:
    the total number of pages of data to display

### getValue

    public java.lang.Object getValue(int aRow,
                                     int aColumn,
                                     java.lang.String type)
                              throws oracle.dss.util.RowOutOfRangeException,
                                     oracle.dss.util.ColumnOutOfRangeException

  Retrieves a data value for the specified row and column intersection.
  Specified by:
    `getValue` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `aRow` - The row to get.
    `aColumn` - The column to get.
    `type` - Type of data to return, such as formatted or unformatted. Valid `type` values are defined in the DataMap.
  Returns:
    The specified type of information for the specified row and column location.
  Throws:
    `oracle.dss.util.RowOutOfRangeException` - If `row` is negative or too large.
    `oracle.dss.util.ColumnOutOfRangeException` - If `column` is negative or too large.
  See Also:
    `DataMap`

### setValue

    public boolean setValue(java.lang.Object aValue,
                            int aRow,
                            int aColumn,
                            java.lang.String type)
                     throws oracle.dss.util.RowOutOfRangeException,
                            oracle.dss.util.ColumnOutOfRangeException

  Specified by:
    `setValue` in interface `oracle.dss.util.DataAccess`
  Throws:
    `oracle.dss.util.RowOutOfRangeException`
    `oracle.dss.util.ColumnOutOfRangeException`

### getSliceLabel

    public java.lang.Object getSliceLabel(int edge,
                                          int slice,
                                          java.lang.String type)
                                   throws oracle.dss.util.EdgeOutOfRangeException,
                                          oracle.dss.util.SliceOutOfRangeException

  Retrieves the label for the specified column.
  Specified by:
    `getSliceLabel` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `edge` - Edge of interest.
    `slice` - The slice whose label is desired.
    `type` - A constant that specifies the kind of metadata that you want. Valid `type` values are defined in the MetadataMap.
  Returns:
    The label (or metadata) for the location on the specified edge.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is out of range.
    `oracle.dss.util.SliceOutOfRangeException` - If `slice` is negative or too large.

### getEdgeCurrentSlice

    public int getEdgeCurrentSlice(int edge)
                            throws oracle.dss.util.EdgeOutOfRangeException

  Retrieves the number of the current slice. The number that this method returns is not the regular index of the page dimension. Instead, page numbers begin at 1 and are incremented as in the following example:

  Suppose that you have a Time dimension and a City dimension on the page edge. Suppose the City dimension has three members. The first five pages are as follows:

  - 0. Time member 0; City member 0
  - 1. Time member 0; City member 1
  - 2. Time member 0; City member 2
  - 3. Time member 1; City member 0
  - 4. Time member 1; City member 1
  Specified by:
    `getEdgeCurrentSlice` in interface `oracle.dss.util.DataAccess`
  Returns:
    The current slice of the edge.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is out of range.

### changeEdgeCurrentSlice

    public boolean changeEdgeCurrentSlice(int edge,
                                          int slice)
                                   throws oracle.dss.util.EdgeOutOfRangeException,
                                          oracle.dss.util.SliceOutOfRangeException,
                                          oracle.dss.util.DataDirectorException

  Changes the current slice of data on the given edge.
  Specified by:
    `changeEdgeCurrentSlice` in interface `oracle.dss.util.DataDirector`
  Parameters:
    `edge` - The edge on which to make the change.
    `slice` - The slice to make current. Page numbers begin at zero and are incremented as in the following example:

    Suppose that you have a Time dimension and a City dimension on the page edge. Suppose the City dimension has three members. The first five pages are as follows:

    - 0. Time member 0; City member 0
    - 1. Time member 0; City member 1
    - 2. Time member 0; City member 2
    - 3. Time member 1; City member 0
    - 4. Time member 1; City member 1
  Returns:
    `true` if the page change is successful, `false` if not.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is too large.
    `oracle.dss.util.SliceOutOfRangeException` - If `slice` is too large.
    `oracle.dss.util.DataDirectorException` - If a data provider error occurs.

### getLayerCount

    public int getLayerCount(int edge)
                      throws oracle.dss.util.EdgeOutOfRangeException

  Retrieves the number of layers on the specified edge.
  Specified by:
    `getLayerCount` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `edge` - A constant that represents the edge of interest. The constants are defined in the DataDirector implementation.
  Returns:
    The number of layers on the specified edge.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is out of range.

### getSliceMemberCount

    public int getSliceMemberCount(int edge,
                                   int slice)
                            throws oracle.dss.util.EdgeOutOfRangeException,
                                   oracle.dss.util.SliceOutOfRangeException

  Retrieves the number of logical layers at the specified location on the specified edge. This method is useful in cases of asymmetry where the dimensions on an edge do not all span the same layers.
  Specified by:
    `getSliceMemberCount` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `edge` - A constant that represents the edge of interest. Constants are defined in the DataDirector implementation.
    `slice` - The slice that identifies a location along the edge of interest. The slice is zero-based. Each member in the innermost layer has a unique slice. In outer layers, any slice that the outer layer spans can be used.
  Returns:
    The number of logical layers at the specified location on the specified edge.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is out of range.
    `oracle.dss.util.SliceOutOfRangeException` - If `slice` is negative or too large.

### getMemberMetadata

    public java.lang.Object getMemberMetadata(int edge,
                                              int layer,
                                              int slice,
                                              java.lang.String type)
                                       throws oracle.dss.util.EdgeOutOfRangeException,
                                              oracle.dss.util.LayerOutOfRangeException,
                                              oracle.dss.util.SliceOutOfRangeException

  Retrieves a piece of metadata for a dimension member.
  Specified by:
    `getMemberMetadata` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `edge` - A constant that represents the edge of interest. The constants are defined in the DataDirector implementation.
    `layer` - The layer of the member of interest. Valid values are zero to total layers at the specified slice.
    `slice` - The location along the edge. The slice is zero-based. Each member in the innermost layer has a unique slice. In outer layers, any slice that the outer member spans can be used.
    `type` - A constant that specifies the kind of metadata that you want. Valid `type` values are defined in the MetadataMap.
  Returns:
    The requested metadata.
  Throws:
    `oracle.dss.util.LayerOutOfRangeException` - If `layer` is negative or too large.
    `oracle.dss.util.SliceOutOfRangeException` - If `slice` is negative or too large.
    `oracle.dss.util.EdgeOutOfRangeException`

### getMemberExtent

    public int getMemberExtent(int edge,
                               int depth,
                               int slice)
                        throws oracle.dss.util.EdgeOutOfRangeException,
                               oracle.dss.util.LayerOutOfRangeException,
                               oracle.dss.util.SliceOutOfRangeException

  Retrieves the number of slices that a member spans. Views use this method to determine the width of a member in a column header or the height of a member in a row header when not in outline form.
  Specified by:
    `getMemberExtent` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `edge` - A constant that represents the edge of interest. The constants are defined in the DataDirector implementation.
    `depth` - The layer of the dimension of interest. Valid values are zero to total layer at the specified slice.
    `slice` - The location along the edge. The slice is zero-based. Each member in the innermost layer has a unique slice. In outer layers, any slice that the outer member spans can be used.
  Returns:
    The number of slices that the member spans at the specified location.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is too large.
    `oracle.dss.util.LayerOutOfRangeException` - If `layer` is negative or too large
    `oracle.dss.util.SliceOutOfRangeException` - If `slice` is negative or too large
  See Also:
    `DataAccessAdapter.getMemberStartSlice(int, int, int)`

### getMemberDepth

    public int getMemberDepth(int edge,
                              int layer,
                              int slice)
                       throws oracle.dss.util.EdgeOutOfRangeException,
                              oracle.dss.util.LayerOutOfRangeException,
                              oracle.dss.util.SliceOutOfRangeException

  Retrieves the number of layers that a member spans at the specified location on the specified edge. On the column edge, this is the number of heading rows that the specified member spans. On the row edge, this is the number of heading columns that the specified member spans.

  This method is useful only in cases of asymmetry where the members on an edge do not all span one layer and have a depth of 1. Normally, all members have a member depth of 1.

  Specified by:
    `getMemberDepth` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `edge` - A constant that represents the edge of interest. The constants are defined in the DataDirector implementation.
    `layer` - The starting layer of the member, as returned by `getMemberStartLayer`.
    `slice` - The location along the edge. The slice is zero-based. Each member in the innermost layer has a unique slice. In outer layers, any slice that the outer member spans can be used.
  Returns:
    The number of layers that the specified member spans.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is too large.
    `oracle.dss.util.LayerOutOfRangeException` - If `layer` is negative or too large.
    `oracle.dss.util.SliceOutOfRangeException` - If `slice` is negative or too large.

### getMemberStartLayer

    public int getMemberStartLayer(int edge,
                                   int layer,
                                   int slice)
                            throws oracle.dss.util.EdgeOutOfRangeException,
                                   oracle.dss.util.LayerOutOfRangeException,
                                   oracle.dss.util.SliceOutOfRangeException

  Retrieves the starting slice of a member that spans a number of layers on the specified edge.

  This method is useful only in cases of asymmetry where the members on an edge do not all span one layer. Normally, all members have a member start layer equal to their layer.

  Specified by:
    `getMemberStartLayer` in interface `oracle.dss.util.DataAccess`
  Parameters:
    `edge` - A constant that represents the edge of interest. The constants are defined in the DataDirector implementation.
    `layer` - The layer of the member
    `slice` - The location along the edge. The slice is zero-based. Each member in the innermost dimension has a unique slice. In outer layers, any slice that the outer member spans can be used.
  Returns:
    The layer at which the specified member starts its layer span.
  Throws:
    `oracle.dss.util.EdgeOutOfRangeException` - If `edge` is too large.
    `oracle.dss.util.LayerOutOfRangeException` - If `layer` is negative or too large.
    `oracle.dss.util.SliceOutOfRangeException` - If `slice` is negative or too large.

### addDataDirectorListener

    public void addDataDirectorListener(oracle.dss.util.DataDirectorListener l)

  NEW Register a listener to the data source for changes.
  Specified by:
    `addDataDirectorListener` in interface `oracle.dss.util.DataDirector`
  Parameters:
    `l` - listener

### removeDataDirectorListener

    public void removeDataDirectorListener(oracle.dss.util.DataDirectorListener l)

  NEW Remove a listener from the data source.
  Specified by:
    `removeDataDirectorListener` in interface `oracle.dss.util.DataDirector`
  Parameters:
    `l` - listener

### refresh

    public boolean refresh()
                    throws oracle.dss.util.DataDirectorException

  Specified by:
    `refresh` in interface `oracle.dss.util.DataDirector`
  Throws:
    `oracle.dss.util.DataDirectorException`

### getSupportedDataMap

    public oracle.dss.util.DataMap getSupportedDataMap()

  Specified by:
    `getSupportedDataMap` in interface `oracle.dss.util.DataDirector`

### getSupportedMetadataMap

    public oracle.dss.util.MetadataMap getSupportedMetadataMap()

  Specified by:
    `getSupportedMetadataMap` in interface `oracle.dss.util.DataDirector`

### getSupportedLayerMetadataMap

    public oracle.dss.util.LayerMetadataMap getSupportedLayerMetadataMap()

  Specified by:
    `getSupportedLayerMetadataMap` in interface `oracle.dss.util.DataDirector`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model Java API Reference 10g Release 3 (10.1.3) B25778-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1997, 2005, Oracle. All rights reserved.